Index: source/graphics/Material.h
===================================================================
--- source/graphics/Material.h	(revision 11919)
+++ source/graphics/Material.h	(working copy)
@@ -38,6 +38,12 @@
 
 	void SetDiffuseTexture(const CTexturePtr& texture);
 	const CTexturePtr& GetDiffuseTexture() const { return m_DiffuseTexture; }
+	
+	void SetNormalTexture(const CTexturePtr& texture);
+	const CTexturePtr& GetNormalTexture() const { return m_NormalTexture; }
+	
+	void SetSpecularTexture(const CTexturePtr& texture);
+	const CTexturePtr& GetSpecularTexture() const { return m_SpecularTexture; }
 
 	void SetShaderEffect(const CStr& effect);
 	CStrIntern GetShaderEffect() const { return m_ShaderEffect; }
@@ -50,6 +56,8 @@
 
 private:
 	CTexturePtr m_DiffuseTexture;
+	CTexturePtr m_NormalTexture;
+	CTexturePtr m_SpecularTexture;
 	CStrIntern m_ShaderEffect;
 	CShaderDefines m_ShaderDefines;
 	CShaderUniforms m_StaticUniforms;
Index: source/graphics/TerrainTextureManager.cpp
===================================================================
--- source/graphics/TerrainTextureManager.cpp	(revision 11919)
+++ source/graphics/TerrainTextureManager.cpp	(working copy)
@@ -143,6 +143,17 @@
 		// multiple extensions.
 		if(!tex_is_known_extension(pathnames[i]))
 			continue;
+		
+		// if this is a texture file, ensure that its basename does not
+		// end in "_norm" or "_spec", as those are not stand-alone texture maps
+		const Path base = pathnames[i].Basename();
+		const size_t underscore = base.string().find_last_of('_');
+		if(underscore != VfsPath::String::npos)
+		{
+			const Path p = base.string().substr(underscore);			
+			if (p == L"_norm" || p == L"_spec")
+				continue;
+		}
 
 		VfsPath pathnameXML = pathnames[i].ChangeExtension(L".xml");
 		CTerrainPropertiesPtr myprops;
Index: source/graphics/TerrainProperties.cpp
===================================================================
--- source/graphics/TerrainProperties.cpp	(revision 11919)
+++ source/graphics/TerrainProperties.cpp	(working copy)
@@ -103,6 +103,8 @@
 	ATTR(movementclass);
 	ATTR(angle);
 	ATTR(size);
+	ATTR(normalmap);
+	ATTR(specularmap);
 	#undef ELMT
 	#undef ATTR
 
@@ -154,6 +156,14 @@
 		{
 			m_MovementClass = attr.Value;
 		}
+		else if (attr.Name == attr_normalmap)
+		{
+			m_NormalMap = attr.Value;
+		}
+		else if (attr.Name == attr_specularmap)
+		{
+			m_SpecularMap = attr.Value;
+		}
 	}
 }
 
Index: source/graphics/ObjectEntry.h
===================================================================
--- source/graphics/ObjectEntry.h	(revision 11919)
+++ source/graphics/ObjectEntry.h	(working copy)
@@ -47,6 +47,8 @@
 	CObjectBase* m_Base;
 
 	VfsPath m_TextureName;
+	VfsPath m_NormalName;
+	VfsPath m_SpecularName;
 	// model name
 	VfsPath m_ModelName;
 	// colour (used when doing alpha-channel colouring, but not doing player-colour)
Index: source/graphics/mikktspace.h
===================================================================
--- source/graphics/mikktspace.h	(revision 0)
+++ source/graphics/mikktspace.h	(revision 0)
@@ -0,0 +1,146 @@
+/** \file mikktspace/mikktspace.h
+ *  \ingroup mikktspace
+ */
+/**
+ *  Copyright (C) 2011 by Morten S. Mikkelsen
+ *
+ *  This software is provided 'as-is', without any express or implied
+ *  warranty.  In no event will the authors be held liable for any damages
+ *  arising from the use of this software.
+ *
+ *  Permission is granted to anyone to use this software for any purpose,
+ *  including commercial applications, and to alter it and redistribute it
+ *  freely, subject to the following restrictions:
+ *
+ *  1. The origin of this software must not be misrepresented; you must not
+ *     claim that you wrote the original software. If you use this software
+ *     in a product, an acknowledgment in the product documentation would be
+ *     appreciated but is not required.
+ *  2. Altered source versions must be plainly marked as such, and must not be
+ *     misrepresented as being the original software.
+ *  3. This notice may not be removed or altered from any source distribution.
+ */
+
+#ifndef __MIKKTSPACE_H__
+#define __MIKKTSPACE_H__
+
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/* Author: Morten S. Mikkelsen
+ * Version: 1.0
+ *
+ * The files mikktspace.h and mikktspace.c are designed to be
+ * stand-alone files and it is important that they are kept this way.
+ * Not having dependencies on structures/classes/libraries specific
+ * to the program, in which they are used, allows them to be copied
+ * and used as is into any tool, program or plugin.
+ * The code is designed to consistently generate the same
+ * tangent spaces, for a given mesh, in any tool in which it is used.
+ * This is done by performing an internal welding step and subsequently an order-independent evaluation
+ * of tangent space for meshes consisting of triangles and quads.
+ * This means faces can be received in any order and the same is true for
+ * the order of vertices of each face. The generated result will not be affected
+ * by such reordering. Additionally, whether degenerate (vertices or texture coordinates)
+ * primitives are present or not will not affect the generated results either.
+ * Once tangent space calculation is done the vertices of degenerate primitives will simply
+ * inherit tangent space from neighboring non degenerate primitives.
+ * The analysis behind this implementation can be found in my master's thesis
+ * which is available for download --> http://image.diku.dk/projects/media/morten.mikkelsen.08.pdf
+ * Note that though the tangent spaces at the vertices are generated in an order-independent way,
+ * by this implementation, the interpolated tangent space is still affected by which diagonal is
+ * chosen to split each quad. A sensible solution is to have your tools pipeline always
+ * split quads by the shortest diagonal. This choice is order-independent and works with mirroring.
+ * If these have the same length then compare the diagonals defined by the texture coordinates.
+ * XNormal which is a tool for baking normal maps allows you to write your own tangent space plugin
+ * and also quad triangulator plugin.
+ */
+
+
+typedef int tbool;
+typedef struct SMikkTSpaceContext SMikkTSpaceContext;
+
+typedef struct
+{
+	// Returns the number of faces (triangles/quads) on the mesh to be processed.
+	int (*m_getNumFaces)(const SMikkTSpaceContext * pContext);
+
+	// Returns the number of vertices on face number iFace
+	// iFace is a number in the range {0, 1, ..., getNumFaces()-1}
+	int (*m_getNumVerticesOfFace)(const SMikkTSpaceContext * pContext, const int iFace);
+
+	// returns the position/normal/texcoord of the referenced face of vertex number iVert.
+	// iVert is in the range {0,1,2} for triangles and {0,1,2,3} for quads.
+	void (*m_getPosition)(const SMikkTSpaceContext * pContext, float fvPosOut[], const int iFace, const int iVert);
+	void (*m_getNormal)(const SMikkTSpaceContext * pContext, float fvNormOut[], const int iFace, const int iVert);
+	void (*m_getTexCoord)(const SMikkTSpaceContext * pContext, float fvTexcOut[], const int iFace, const int iVert);
+
+	// either (or both) of the two setTSpace callbacks can be set.
+	// The call-back m_setTSpaceBasic() is sufficient for basic normal mapping.
+
+	// This function is used to return the tangent and fSign to the application.
+	// fvTangent is a unit length vector.
+	// For normal maps it is sufficient to use the following simplified version of the bitangent which is generated at pixel/vertex level.
+	// bitangent = fSign * cross(vN, tangent);
+	// Note that the results are returned unindexed. It is possible to generate a new index list
+	// But averaging/overwriting tangent spaces by using an already existing index list WILL produce INCRORRECT results.
+	// DO NOT! use an already existing index list.
+	void (*m_setTSpaceBasic)(const SMikkTSpaceContext * pContext, const float fvTangent[], const float fSign, const int iFace, const int iVert);
+
+	// This function is used to return tangent space results to the application.
+	// fvTangent and fvBiTangent are unit length vectors and fMagS and fMagT are their
+	// true magnitudes which can be used for relief mapping effects.
+	// fvBiTangent is the "real" bitangent and thus may not be perpendicular to fvTangent.
+	// However, both are perpendicular to the vertex normal.
+	// For normal maps it is sufficient to use the following simplified version of the bitangent which is generated at pixel/vertex level.
+	// fSign = bIsOrientationPreserving ? 1.0f : (-1.0f);
+	// bitangent = fSign * cross(vN, tangent);
+	// Note that the results are returned unindexed. It is possible to generate a new index list
+	// But averaging/overwriting tangent spaces by using an already existing index list WILL produce INCRORRECT results.
+	// DO NOT! use an already existing index list.
+	void (*m_setTSpace)(const SMikkTSpaceContext * pContext, const float fvTangent[], const float fvBiTangent[], const float fMagS, const float fMagT,
+						const tbool bIsOrientationPreserving, const int iFace, const int iVert);
+} SMikkTSpaceInterface;
+
+struct SMikkTSpaceContext
+{
+	SMikkTSpaceInterface * m_pInterface;	// initialized with callback functions
+	void * m_pUserData;						// pointer to client side mesh data etc. (passed as the first parameter with every interface call)
+};
+
+// these are both thread safe!
+tbool genTangSpaceDefault(const SMikkTSpaceContext * pContext);	// Default (recommended) fAngularThreshold is 180 degrees (which means threshold disabled)
+tbool genTangSpace(const SMikkTSpaceContext * pContext, const float fAngularThreshold);
+
+
+// To avoid visual errors (distortions/unwanted hard edges in lighting), when using sampled normal maps, the
+// normal map sampler must use the exact inverse of the pixel shader transformation.
+// The most efficient transformation we can possibly do in the pixel shader is
+// achieved by using, directly, the "unnormalized" interpolated tangent, bitangent and vertex normal: vT, vB and vN.
+// pixel shader (fast transform out)
+// vNout = normalize( vNt.x * vT + vNt.y * vB + vNt.z * vN );
+// where vNt is the tangent space normal. The normal map sampler must likewise use the
+// interpolated and "unnormalized" tangent, bitangent and vertex normal to be compliant with the pixel shader.
+// sampler does (exact inverse of pixel shader):
+// float3 row0 = cross(vB, vN);
+// float3 row1 = cross(vN, vT);
+// float3 row2 = cross(vT, vB);
+// float fSign = dot(vT, row0)<0 ? -1 : 1;
+// vNt = normalize( fSign * float3(dot(vNout,row0), dot(vNout,row1), dot(vNout,row2)) );
+// where vNout is the sampled normal in some chosen 3D space.
+//
+// Should you choose to reconstruct the bitangent in the pixel shader instead
+// of the vertex shader, as explained earlier, then be sure to do this in the normal map sampler also.
+// Finally, beware of quad triangulations. If the normal map sampler doesn't use the same triangulation of
+// quads as your renderer then problems will occur since the interpolated tangent spaces will differ
+// eventhough the vertex level tangent spaces match. This can be solved either by triangulating before
+// sampling/exporting or by using the order-independent choice of diagonal for splitting quads suggested earlier.
+// However, this must be used both by the sampler and your tools/rendering pipeline.
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
Index: source/graphics/weldmesh.cpp
===================================================================
--- source/graphics/weldmesh.cpp	(revision 0)
+++ source/graphics/weldmesh.cpp	(revision 0)
@@ -0,0 +1,196 @@
+#include "precompiled.h"
+
+/**
+ *  Copyright (C) 2011 by Morten S. Mikkelsen
+ *
+ *  This software is provided 'as-is', without any express or implied
+ *  warranty.  In no event will the authors be held liable for any damages
+ *  arising from the use of this software.
+ *
+ *  Permission is granted to anyone to use this software for any purpose,
+ *  including commercial applications, and to alter it and redistribute it
+ *  freely, subject to the following restrictions:
+ *
+ *  1. The origin of this software must not be misrepresented; you must not
+ *     claim that you wrote the original software. If you use this software
+ *     in a product, an acknowledgment in the product documentation would be
+ *     appreciated but is not required.
+ *  2. Altered source versions must be plainly marked as such, and must not be
+ *     misrepresented as being the original software.
+ *  3. This notice may not be removed or altered from any source distribution.
+ */
+
+
+#include "weldmesh.h"
+#include <string.h>
+#include <assert.h>
+
+#ifdef __APPLE__
+#include <stdlib.h>  /* OSX gets its malloc stuff through here */
+#else
+#include <malloc.h> 
+#endif
+
+static void MergeVertsFast(int * piCurNrUniqueVertices, int * piRemapTable, float * pfVertexDataOut, int * piVertexIDs,
+			  const float pfVertexDataIn[], const int iNrVerticesIn, const int iFloatsPerVert,
+			  const int iL_in, const int iR_in, const int iChannelNum);
+
+int WeldMesh(int * piRemapTable, float * pfVertexDataOut,
+			  const float pfVertexDataIn[], const int iNrVerticesIn, const int iFloatsPerVert)
+{
+	int iUniqueVertices = 0, i=0;
+	int * piVertexIDs = NULL;
+	if(iNrVerticesIn<=0) return 0;
+
+
+	iUniqueVertices = 0;
+	piVertexIDs = (int *) malloc(sizeof(int)*iNrVerticesIn);
+	if(piVertexIDs!=NULL)
+	{
+		for(i=0; i<iNrVerticesIn; i++)
+		{
+			piRemapTable[i] = -1;
+			piVertexIDs[i] = i;
+		}
+
+		MergeVertsFast(&iUniqueVertices, piRemapTable, pfVertexDataOut, piVertexIDs,
+										 pfVertexDataIn, iNrVerticesIn, iFloatsPerVert, 0, iNrVerticesIn-1, 0);
+
+		free(piVertexIDs);
+
+		// debug check
+		for(i=0; i<iUniqueVertices; i++)
+			assert(piRemapTable[i]>=0);
+	}
+
+	return iUniqueVertices;
+}
+
+
+
+
+
+static void MergeVertsFast(int * piCurNrUniqueVertices, int * piRemapTable, float * pfVertexDataOut, int * piVertexIDs,
+			  const float pfVertexDataIn[], const int iNrVerticesIn, const int iFloatsPerVert,
+			  const int iL_in, const int iR_in, const int iChannelNum)
+{
+	const int iCount = iR_in-iL_in+1;
+	int l=0;
+	float fMin, fMax, fAvg;
+	assert(iCount>0);
+	// make bbox
+	fMin = pfVertexDataIn[ piVertexIDs[iL_in]*iFloatsPerVert + iChannelNum]; fMax = fMin;
+	for(l=(iL_in+1); l<=iR_in; l++)
+	{
+		const int index = piVertexIDs[l]*iFloatsPerVert + iChannelNum;
+		const float fVal = pfVertexDataIn[index];
+		if(fMin>fVal) fMin=fVal;
+		else if(fMax<fVal) fMax=fVal;
+	}
+
+	// terminate recursion when the separation/average value
+	// is no longer strictly between fMin and fMax values.
+	fAvg = 0.5f*(fMax + fMin);
+	if(fAvg<=fMin || fAvg>=fMax || iCount==1)
+	{
+		if((iChannelNum+1) == iFloatsPerVert || iCount==1)	// we are done, weld by hand
+		{
+			int iUniqueNewVertices = 0;
+			float * pfNewUniVertsOut = &pfVertexDataOut[ piCurNrUniqueVertices[0]*iFloatsPerVert ];
+
+			for(l=iL_in; l<=iR_in; l++)
+			{
+				const int index = piVertexIDs[l]*iFloatsPerVert;
+
+				int iFound = 0;	// didn't find copy yet.
+				int l2=0;
+				while(l2<iUniqueNewVertices && iFound==0)
+				{
+					const int index2 = l2*iFloatsPerVert;
+
+					int iAllSame = 1;
+					int c=0;
+					while(iAllSame!=0 && c<iFloatsPerVert)
+					{
+						iAllSame &= (pfVertexDataIn[index+c] == pfNewUniVertsOut[index2+c] ? 1 : 0);
+						++c;
+					}
+
+					iFound = iAllSame;
+					if(iFound==0) ++l2;
+				}
+				
+				// generate new entry
+				if(iFound==0)
+				{
+					memcpy(pfNewUniVertsOut+iUniqueNewVertices*iFloatsPerVert, pfVertexDataIn+index, sizeof(float)*iFloatsPerVert);
+					++iUniqueNewVertices;
+				}
+
+				assert(piRemapTable[piVertexIDs[l]] == -1);	// has not yet been assigned
+				piRemapTable[piVertexIDs[l]] = piCurNrUniqueVertices[0] + l2;
+			}
+
+			piCurNrUniqueVertices[0] += iUniqueNewVertices;
+		}
+		else
+		{
+			MergeVertsFast(piCurNrUniqueVertices, piRemapTable, pfVertexDataOut, piVertexIDs,
+						   pfVertexDataIn, iNrVerticesIn, iFloatsPerVert,
+							iL_in, iR_in, iChannelNum+1);
+		}
+	}
+	else
+	{
+		int iL=iL_in, iR=iR_in, index;
+
+		// seperate (by fSep) all points between iL_in and iR_in in pTmpVert[]
+		while(iL < iR)
+		{
+			int iReadyLeftSwap = 0;
+			int iReadyRightSwap = 0;
+			while(iReadyLeftSwap==0 && iL<iR)
+			{
+				assert(iL>=iL_in && iL<=iR_in);
+				index = piVertexIDs[iL]*iFloatsPerVert+iChannelNum;
+				iReadyLeftSwap = !(pfVertexDataIn[index]<fAvg) ? 1 : 0;
+				if(iReadyLeftSwap==0) ++iL;
+			}
+			while(iReadyRightSwap==0 && iL<iR)
+			{
+				assert(iR>=iL_in && iR<=iR_in);
+				index = piVertexIDs[iR]*iFloatsPerVert+iChannelNum;
+				iReadyRightSwap = pfVertexDataIn[index]<fAvg ? 1 : 0;
+				if(iReadyRightSwap==0) --iR;
+			}
+			assert( (iL<iR) || (iReadyLeftSwap==0 || iReadyRightSwap==0));
+
+			if(iReadyLeftSwap!=0 && iReadyRightSwap!=0)
+			{
+				int iID=0;
+				assert(iL<iR);
+				iID = piVertexIDs[iL];
+				piVertexIDs[iL] = piVertexIDs[iR];
+				piVertexIDs[iR] = iID;
+				++iL; --iR;
+			}
+		}
+
+		assert(iL==(iR+1) || (iL==iR));
+		if(iL==iR)
+		{
+			const int index = piVertexIDs[iR]*iFloatsPerVert+iChannelNum;
+			const int iReadyRightSwap = pfVertexDataIn[index]<fAvg ? 1 : 0;
+			if(iReadyRightSwap!=0) ++iL;
+			else --iR;
+		}
+
+		// recurse
+		if(iL_in <= iR)
+			MergeVertsFast(piCurNrUniqueVertices, piRemapTable, pfVertexDataOut, piVertexIDs,
+						   pfVertexDataIn, iNrVerticesIn, iFloatsPerVert, iL_in, iR, iChannelNum);	// weld all left of fSep
+		if(iL <= iR_in)
+			MergeVertsFast(piCurNrUniqueVertices, piRemapTable, pfVertexDataOut, piVertexIDs,
+						   pfVertexDataIn, iNrVerticesIn, iFloatsPerVert, iL, iR_in, iChannelNum);	// weld all right of (or equal to) fSep
+	}
+}
\ No newline at end of file
Index: source/graphics/TerrainTextureEntry.h
===================================================================
--- source/graphics/TerrainTextureEntry.h	(revision 11919)
+++ source/graphics/TerrainTextureEntry.h	(working copy)
@@ -47,6 +47,8 @@
 	CTerrainPropertiesPtr m_pProperties;
 	
 	CTexturePtr m_Texture;
+	CTexturePtr m_Normal;
+	CTexturePtr m_Specular;
 
 	CMatrix3D m_TextureMatrix;
 	
@@ -79,6 +81,14 @@
 		return m_Texture;
 	}
 
+	const CTexturePtr& GetNormal() {
+		return m_Normal;
+	}
+
+	const CTexturePtr& GetSpecular() {
+		return m_Specular;
+	}
+
 	// Returns a matrix of the form [c 0 -s 0; -s 0 -c 0; 0 0 0 0; 0 0 0 1]
 	// mapping world-space (x,y,z,1) coordinates onto (u,v,0,1) texcoords
 	const float* GetTextureMatrix();
